#WBL 14 April 2008 crossover $Revision: 1.12 $

#WBL 19 Apr 2008 Move guts to syntax.awk
#WBL 15 Apr 2008 Apply r1.15 random_syntax.awk bugfixes
#WBL 11 Apr 2008 Add pPopSize
#WBL 11 Apr 2008 Add ramped-half-half based on GProc chrome.cxx r1.199

BEGIN{
  command_options("crossover.awk $Revision: 1.12 $");
}

#(index($0,"#")==1 && index($0,"Revision:")) {print $0,file,FILENAME;}

(file>1 && $3=="<start>") {line[++id] = $0;}

END{
  check();
  for(i=1;i<=pPopSize;i++) {
    p1 = 1+rnd(id);
    p2 = 1+rnd(id);
    printf("echo \"id\" %5d %6s x %5s\n",
	   i,substr(line[p1],3,5),substr(line[p2],3,6));
    printf("# %5d",i);
    if(crossover(p1,p2)==0) { printf(" failed\n"); --i; continue;}
    print_prog();
  }
  check();
  printf("#\n");
}

function crossover(id1,id2, 
		   n1,t1,i,r1,rule1,r,cross,ncross,pc1,
		   x,n2,t2,pc2,pc11,status,ntries) {
do{
#randomly choose two compatible crossover points: one in id1 and one in id2
  n1=split(line[id1],t1);
  r1=0;
  for(i=3;i<=n1;i++) {r=t1[i];
    #if(r in rule || r in rule_l || r in rule_r) rule1[++r1]=i;
    if(r in rule_l || r in rule_r) rule1[++r1]=i;
  }assert(r1>0,"crossover");
  do{
    for(i in cross) delete cross[i];ncross=0;
    pc1=rule1[1+rnd(r1)];
    x=t1[pc1];
    n2=split(line[id2],t2);
    for(i=3;i<=n2;i++) {
      if(x==t2[i]) cross[++ncross]=i;
      #printf("i=%d, t[%d]=%s\n",i,i,t[i])> "/dev/stderr";
    }
  }while(ncross==0);
  pc2=cross[1+rnd(ncross)];

  #printf(" id1=%d, id2=%d, n1=%d, pc1=%s, x=%s,ncross=%s, pc2=%s\n",id1,id2,n1,pc1,x,ncross,pc2)> "/dev/stderr";

  for(i in tree) delete tree[i]; IP=0;
  for(i=3;i<pc1;i++) treenode(i,t1);    #set globals IP,tree
  #printf("traverse(%d,t2,1)\n",pc2);
  traverse(pc2,t2,1);                   #set globals IP and tree
  #printf("Discard t(%d,t1,0)\n",pc1);
  pc11=traverse(pc1,t1,0);              #find end of removed tree1
  #printf("Finish %d,%d\n",pc11,n1);
  for(i=pc11;i<=n1;i++) treenode(i,t1); #set globals IP,tree

  #printf("%5d %5d %s\n",pc1,id1,line[id1]);
  #for(i=1;i<=r1;i++) printf("%s ",rule1[i]);printf("\n")
  #printf("%5d %5d %s\n",pc2,id2,line[id2]);
  #printf("IP=%s,",IP); for(i=1;i<=IP;i++) printf(" %d",tree[i]); printf("\n");

  IP=0; PC=0; pPC=0;
  prog[PC] = "<start>"
  check();
  status=SubInit_(1,pInitExpr);
  #printf("SubInit(1,%d) returned %s\n",pInitExpr,status);
}while(!status && ++ntries<10);
  return status;
}


