#WBL 11 April 2008 $Revision: 1.6 $
#calculate fitness

BEGIN{
  if(max=="") max=100;
  print "#fitness.awk $Revision: 1.6 $ max=",max,strftime();
}

(index($0,"#")==1 && index($0,"Revision:")) {print $0,FILENAME;}

($1=="id") {
    fitness(id,tp,fp);
    id=$0;
    tp=fp="";
}

(index($1,"pos")) {
    split($1,t,":");
    tp=t[2];
}
(index($1,"neg")) {
    split($1,t,":");
    fp=t[2];
}


END{
    fitness(id,tp,fp);
}

function fitness(id,tp,fp, tn,pen1,pen2) {
    if(tp>max || fp>max) {print "fitness.awk ERROR max="max",fitness("id","tp","fp") FNR="FNR > "/dev/stderr"; exit 1;}
    if(id=="") return;
    #printf("fitness(%s,%s,%s)\n",id,tp,fp);
    tn    = (fp=="")?   0 : (max-fp);
    pen1  = (tp=="")? max : 0;
    pen1 += (fp=="")? max : 0;
    pen2  = (tp==0 && tn==max || tp==max && tn==0)? max : 0;
    printf("%4d %s\n",tp+tn-pen1-pen2,id);
}

