#WBL  14 April 2008 $Revision: 1.17a $

#WBL 25 Apr Tidy up for RE_gp.tar, restore mutation and shrink
#           use RE_gp.human.demo
#WBL 21 Apr pops16 ok. Demonstrate big pops are feasible
#WBL 20 Apr pops15 worked. Try simplifying smaller pop no mutation
#WBL 19 Apr Use same training data for each generation, use syntax.awk
#           add mutation, reduce pMaxExpr to 100
#WBL 18 Apr Smaller number of negative correlation examples
#WBL 15 Apr Format of fitness.awk output changed reduce and pInitExpr
#           For debug make best and best2 separate for each gen
#           [reducex pop & tail]

echo -n "Gen $1 "

chmod +x /tmp/pop.$1

/tmp/pop.$1 /tmp/RE_gp.plant.neg.txt /tmp/RE_gp.human.pos.txt  | \
    gawk -f fitness.awk -v max=5 |grep -v "#"| sort -n | tail -20 >! /tmp/pop.$1.best
gawk 'END{printf("max fitness %s",$1);}' /tmp/pop.$1.best
gawk -f select.awk /tmp/pop.$1.best /tmp/pop.$1 >! /tmp/pop.$1.best2
gawk -f syntax.awk -f stats.awk syntax.txt /tmp/pop.$1.best2

echo " New $2"

gawk -f syntax.awk -f shrink.awk  \
     -v "pInitExpr=17" -v "pMaxExpr=1000000" \
     -v "seed=$3" -v "pPopSize=10"  \
     syntax.txt /tmp/pop.$1.best2 >! /tmp/pop.$2

gawk -f syntax.awk -f mutation.awk  \
     -v "pInitExpr=17" -v "pMaxExpr=1000000" \
     -v "seed=$3" -v "pPopSize=5"  \
     syntax.txt /tmp/pop.$1.best2 >> /tmp/pop.$2

gawk -f syntax.awk -f crossover.awk  \
     -v "pInitExpr=17" -v "pMaxExpr=1000000" \
     -v "seed=$3" -v "pPopSize=90"  \
     syntax.txt /tmp/pop.$1.best2 >> /tmp/pop.$2

#
exit
