#WBL 19 April 2008 mutation based crossover.awk r1.11 $Revision: 1.4 $

BEGIN{
  command_options("mutation.awk $Revision: 1.4 $");
}

#(index($0,"#")==1 && index($0,"Revision:")) {print $0,file,FILENAME;}

(file>1 && $3=="<start>") {line[++id] = $0;}

END{
  check();
  for(i=1;i<=pPopSize;i++) {
    p1 = 1+rnd(id);
    printf("echo \"id\" %5dM %6s\n",
	   i,substr(line[p1],3,6));
    printf("# %5dM",i);
    if(mutate(p1)==0) { printf(" failed\n"); --i; continue;} #eg cant shrink 'T'
    print_prog();
  }
  check();
  printf("#\n");
}

function mutate(id1, 
		   n1,t1,i,r1,rule1,r,cross,ncross,pc1,
		x,pc11,s1,status,same,ntries,ntries2) {
do{
#randomly choose mutation point
  n1=split(line[id1],t1);
  r1=0;
  for(i=3;i<=n1;i++) {r=t1[i];
    if(r in rule_l || r in rule_r) rule1[++r1]=i;
  }assert(r1>0,"mutation");
  ntries2=0;
  do {
  pc1=rule1[1+rnd(r1)];
  pc11=traverse(pc1,t1,0);              #find end of removed tree1

  #if(ntries==0 && ntries2==0) {
  #  printf(" old %s\n",id1)                 ;
  #  for(i=3;i<=n1;i++) {printf(" %s",t1[i]) }
  #  printf("\n")                            ;
  #}
  #printf(" id1=%d, pc1=%s, pc11=%d, x=%s\n",id1,pc1,pc11,t1[pc1]);

#create small random subtree with same root as pc1
  PC=0; pPC=0;
  prog[PC] = t1[pc1];
  #full or half full makes no difference since mindepth=0
  #go to depth=1
  SubInit(1,0,0,0);
  #printf(" new fragment %d :",PC);
  #for(i=0;i<=PC;i++) printf("%s ",prog[i]);printf("\n");
  } while((PC+1)>(pc11-pc1) && ++ntries2<100); #ensure new tree is not bigger than removed tree
  if((PC+1)>(pc11-pc1)) {
    #if(ntries==9)
    #  print "Suggesting replacing tree by bigger",id1,ntries,ntries2 > "/dev/stderr";
    continue;
  }


  for(i in tree) delete tree[i]; IP=0;
  for(i=3;i<pc1;i++) treenode(i,t1);    #set globals IP,tree
  #printf("traverse(0,prog,1)\n");
  traverse(0,prog,1);                   #set globals IP and tree
  #printf("Discard t(%d,t1,0)\n",pc1);
  pc11=traverse(pc1,t1,0);              #find end of removed tree1
  #printf("Finish %d,%d\n",pc11,n1);
  for(i=pc11;i<=n1;i++) treenode(i,t1); #set globals IP,tree

  #printf("%5d %5d %s\n",pc1,id1,line[id1]);
  #for(i=1;i<=r1;i++) printf("%s ",rule1[i]);printf("\n")
  #printf("%5d %5d %s\n",pc2,id2,line[id2]);
  #printf("IP=%s,",IP); for(i=1;i<=IP;i++) printf(" %d",tree[i]); printf("\n");

  IP=0; PC=0; pPC=0;
  prog[PC] = "<start>"
  check();
  status=s1=SubInit_(1,pInitExpr);
  if(s1) {
    same=1;
    for(i=3;i<=n1 && same;i++) {if(t1[i]!=prog[i-3]) same=0;}
    if(same) status = 0;
  }
  #printf("SubInit_(1,%d) returned %s, same=%d status=%d\n",pInitExpr,s1,same,status);
}while(!status && ++ntries<10);
  return status;
}


