#WBL 19 April 2008 mutation based mutation.awk r1.3 $Revision: 1.3 $

BEGIN{
  command_options("shrink.awk $Revision: 1.3 $");
}

#(index($0,"#")==1 && index($0,"Revision:")) {print $0,file,FILENAME;}

(file>1 && $3=="<start>") {line[++id] = $0;}

END{
  check();
  for(i=1;i<=pPopSize;i++) {
    p1 = 1+rnd(id);
    printf("echo \"id\" %5dS %6s\n",
	   i,substr(line[p1],3,6));
    printf("# %5dS",i);
    if(shrink(p1)==0) { printf(" failed\n"); --i; continue;} #eg cant shrink 'T'
    print_prog();
  }
  check();
  printf("#\n");
}

function findmatches(ip,prog,target,
		     args,n,t) {
  args = 1;
  while (args > 0) {
    n=(prog[ip] in rule)? split(rule[prog[ip]],t) : 
      (prog[ip] in rule_l || prog[ip] in rule_r)? 1 : 0;
    args=args+n-1;
    if(prog[ip]==target) matches[++IM]=ip;
    ip++;
  }
}
function shrink(id1, 
		   n1,t1,i,r1,rule1,r,cross,ncross,pc1,
		x,pc11,pc2,status,ntries,ntries2) {
do{
#randomly choose mutation point
  n1=split(line[id1],t1);
  r1=0;
  for(i=3;i<=n1;i++) {r=t1[i];
    if(r in rule_l || r in rule_r) rule1[++r1]=i;
  }assert(r1>0,"shrink");
  ntries2=0;
  do {
    pc1=rule1[1+rnd(r1)];
    x  =t1[pc1];
    for(i in matches) delete matches[i];IM=0;
    findmatches(pc1,t1,x);
    #if(ntries==0 && ntries2==0) {
    #  printf(" old %s\n",id1)                 ;
    #  for(i=3;i<=n1;i++) {printf(" %s",t1[i]) }
    #  printf("\n")                            ;
    #}
    #printf(" id1=%d, pc1=%s, pc11=%d, x=%s\n",id1,pc1,pc11,t1[pc1]);
  } while(IM<2 && ++ntries2<100); #ensure new tree is smaller than removed tree
  if(IM<2) {
#   if(ntries==9) {
#     print "No suitable smaller tree found",id1,ntries,ntries2,pc1,IM > "/dev/stderr";
#   }
    continue;
  }
  pc2=matches[2+rnd(IM-1)]; #NB ignore first (self) match

  #printf(" id1=%d, id2=%d, n1=%d, pc1=%s, x=%s,IM=%s, pc2=%s\n",id1,id2,n1,pc1,x,IM,pc2)> "/dev/stderr";

  for(i in tree) delete tree[i]; IP=0;
  for(i=3;i<pc1;i++) treenode(i,t1);    #set globals IP,tree
  #printf("traverse(%d,t1,1)\n",pc2);
  traverse(pc2,t1,1);                   #set globals IP and tree
  #printf("Discard t(%d,t1,0)\n",pc1);
  pc11=traverse(pc1,t1,0);              #find end of removed tree1
  #printf("Finish %d,%d\n",pc11,n1);
  for(i=pc11;i<=n1;i++) treenode(i,t1); #set globals IP,tree

  #printf("%5d %5d %s\n",pc1,id1,line[id1]);
  #for(i=1;i<=n1;i++) printf("%s ",t1[i]);printf("\n")
  #printf("IP=%s,",IP); for(i=1;i<=IP;i++) printf(" %d",tree[i]); printf("\n");

  IP=0; PC=0; pPC=0;
  prog[PC] = "<start>"
  check();
  status=SubInit_(1,pInitExpr);
  #printf("SubInit(1,%d) returned %s\n",pInitExpr,status);
}while(!status && ++ntries<10);
  return status;
}


